<!DOCTYPE html>
<html>
  <head>
    <title>FarmBuddy Sensor Data</title>
    <!--<script src="https://code.highcharts.com/highcharts.js"></script>-->
    <link rel="stylesheet" href="https://code.highcharts.com/css/highcharts.css">
<script src="https://code.highcharts.com/stock/highstock.js"></script>



    <style>
      #chart-container {
        height: 600px;
        max-width: 800px;
        margin: 0 auto;
      }
	   #table-wrapper {
        height: 300px;
        max-width: 800px;
        margin: 0 auto;
        overflow: auto;
      }
	  table {
        border-collapse: collapse;
        width: 100%;
        max-width: 800px;
      }
      th, td {
        text-align: left;
        padding: 8px;
        border-bottom: 1px solid #ddd;
      }
      th {
        background-color: #f2f2f2;
      }
      tr:hover {
        background-color: #f5f5f5;
      }
    </style>
  </head>
  <body>
    <form id="date-form">
      <div>
        <label for="start-date">Start Date:</label>
        <input type="date" id="start-date" name="start-date">
      </div>
      <div>
        <label for="end-date">End Date:</label>
        <input type="date" id="end-date" name="end-date">
      </div>
      <button id="submit">Submit</button>
    </form>
    <div id="chart-container"></div>
      <div id="table-wrapper">
      <table>
        <thead>
          <tr>
            <th>Date</th>
            <th>Temperature (C)</th>
            <th>Humidity (%)</th>
            <th>Heat Index</th>
          </tr>
        </thead>
        <tbody id="table-body">
        </tbody>
      </table>
    </div>
    <script>
function getData(start, end) {
  const url = `/data/chart-data?start=${start.toISOString()}&end=${end.toISOString()}`;
  fetch(url)
    .then((res) => res.json())
    .then((data) => {
      const chartData = data.map((obj) => ({
        x: new Date(obj.msg.timestamp).getTime(),
        y: [obj.msg.temp, obj.msg.humid, obj.msg.heatIndex],
      }));

      const tableBody = document.getElementById('table-body');
      tableBody.innerHTML = '';
      data.forEach((obj) => {
        const row = document.createElement('tr');
        const dateCell = document.createElement('td');
        dateCell.textContent = obj.msg.timestamp;
        row.appendChild(dateCell);
        const tempCell = document.createElement('td');
        tempCell.textContent = obj.msg.temp;
        row.appendChild(tempCell);
        const humidCell = document.createElement('td');
        humidCell.textContent = obj.msg.humid;
        row.appendChild(humidCell);
        const heatIndexCell = document.createElement('td');
        heatIndexCell.textContent = obj.msg.heatIndex;
        row.appendChild(heatIndexCell);
        tableBody.appendChild(row);
      });

      const chartOptions = {
        chart: {
          type: "line",
        },
        title: {
          text: "FarmBuddy Sensor Data",
        },
        xAxis: {
          type: "datetime",
          title: {
            text: "Date",
          },
        },
        yAxis: [
          {
            title: {
              text: "Temperature (C)",
            },
          },
          {
            title: {
              text: "Humidity (%)",
            },
            opposite: true,
          },
        ],
        series: [
          {
            name: "Temperature",
            data: chartData.map((data) => [data.x, data.y[0]]),
          },
          {
            name: "Humidity",
            data: chartData.map((data) => [data.x, data.y[1]]),
            yAxis: 1,
          },
          {
            name: "Heat Index",
            data: chartData.map((data) => [data.x, data.y[2]]),
            yAxis: 0,
          },
        ],
        scrollbar: {
          enabled: true,
        },
        rangeSelector: {
          enabled: true,
          inputEnabled: true,
          buttons: [{
            type: 'day',
            count: 1,
            text: '1d'
          }, {
            type: 'week',
            count: 1,
            text: '1w'
          }, {
            type: 'month',
            count: 1,
            text: '1m'
          }, {
            type: 'year',
            count: 1,
            text: '1y'
          }, {
            type: 'all',
            text: 'All'
          }],
           selected: 4 // All
        }
      };

      const chart = Highcharts.chart("chart-container", chartOptions);
    });
}


      function handleSubmit(event) {
        event.preventDefault();
        const start = new Date(document.getElementById('start-date').value);
        const end = new Date(document.getElementById('end-date').value);
        getData(start, end);
        // Save start and end dates in localStorage
        localStorage.setItem('start-date', start.toISOString());
        localStorage.setItem('end-date', end.toISOString());
      }
      const form = document.getElementById('date-form');
      form.addEventListener('submit', handleSubmit);
      //Local storage here
      // Load start and end dates from localStorage if they exist
      const savedStartDate = localStorage.getItem('start-date');
      if (savedStartDate) {
        const startDateInput = document.getElementById('start-date');
        startDateInput.value = savedStartDate.slice(0, 10);
      }
      const savedEndDate = localStorage.getItem('end-date');
      if (savedEndDate) {
        const endDateInput = document.getElementById('end-date');
        endDateInput.value = savedEndDate.slice(0, 10);
      }
      // Call getData on page load if start and end dates are saved
      if (savedStartDate && savedEndDate) {
        const start = new Date(savedStartDate);
        const end = new Date(savedEndDate);
        getData(start, end);
      }
    </script>
  </body>
</html>